<?php
chdir('..');











/*setup*/
echo rex_view::title($this->i18n('capacity_title_extended'));
$content = $buttons = '';



/*save*/
if (rex_post('formsubmit', 'string') == '1') {
	$this->setConfig(rex_post('config', [
		['space', 'int']
	]));
}




/*battery display*/

function folderSize($dir){
	$size = 0;
	foreach (glob(rtrim($dir, '/').'/*', GLOB_NOSORT) as $each) {
		$size += is_file($each) ? filesize($each) : folderSize($each);
	}
	return $size;
}

function formatBytes($size, $precision = 2){
	$base = log($size, 1024);
	$suffixes = array('B', 'KB', 'MB', 'GB', 'TB');
	return round(pow(1024, $base - floor($base)), $precision) .' '. $suffixes[floor($base)];
}

$usage = round(folderSize(getcwd()) / ($this->getConfig('space')*1048576) *100,2);

$core = round( (folderSize(getcwd()."/assets/core")+folderSize(getcwd()."/redaxo/data/core")+folderSize(getcwd()."/redaxo/src/core")) / ($this->getConfig('space')*1048576) *100,2);
$addons = round( (folderSize(getcwd()."/assets/addons")+folderSize(getcwd()."/redaxo/data/addons")+folderSize(getcwd()."/redaxo/src/addons")) / ($this->getConfig('space')*1048576) *100,2);
$cache = round( (folderSize(getcwd()."/redaxo/cache")) / ($this->getConfig('space')*1048576) *100,2);
$media = round( (folderSize(getcwd()."/media")) / ($this->getConfig('space')*1048576) *100,2);
$files = round( (folderSize(getcwd())-folderSize(getcwd()."/redaxo")-folderSize(getcwd()."/media")-folderSize(getcwd()."/assets")) / ($this->getConfig('space')*1048576) *100,2);

$style = "position:relative;display:inline-block;height:100%;";
$content .= '
<div style="position:relative;display:block;width:100%;height:10rem;overflow:hidden;background:white;font-size:0;border-radius:0.5rem;background:whitesmoke;margin:3rem 0 5rem 0;">
<div style="'.$style.'width:'.str_replace(',','.',$core).'%;" title="Core: '.$core.'%" class="btn-info"></div>
<div style="'.$style.'width:'.str_replace(',','.',$addons).'%;" title="Addons: '.$addons.'%" class="btn-save"></div>
<div style="'.$style.'width:'.str_replace(',','.',$cache).'%;" title="Cache: '.$cache.'%" class="btn-setup"></div>
<div style="'.$style.'width:'.str_replace(',','.',$media).'%;" title="Media: '.$media.'%" class="btn-delete"></div>
<div style="'.$style.'width:'.str_replace(',','.',$files).'%;" title="Files: '.$files.'%" class="btn-abort"></div>
</div>
';



/*inputs*/
$formElements = [];
$n = [];
$n['label'] = '';
$n['field'] = '<label>'.rex_i18n::msg('capacity_spacename').'</label><input class="form-control" type="text" name="config[space]" value="'.$this->getConfig('space').'" placeholder="'.rex_i18n::msg('capacity_placeholder').'" style="width:20rem;" />';
$formElements[] = $n;
$fragment = new rex_fragment();
$fragment->setVar('elements', $formElements, false);
$content .= $fragment->parse('core/form/container.php');




/*savebutton*/
$formElements = [];
$n = [];
$n['field'] = '<button class="btn btn-save" type="submit" name="save">'.$this->i18n('capacity_refresh').'</button>';
$formElements[] = $n;
$fragment = new rex_fragment();
$fragment->setVar('elements', $formElements, false);
$buttons = $fragment->parse('core/form/submit.php');
$buttons = '<fieldset class="rex-form-action">'.$buttons.'</fieldset>';




/*form output*/
$fragment = new rex_fragment();
$fragment->setVar('class', 'edit');
$fragment->setVar('title', $this->i18n('capacity_fieldname').': '.formatBytes(folderSize(getcwd())));
$fragment->setVar('body', $content, false);
$fragment->setVar('buttons', $buttons, false);
$output = $fragment->parse('core/page/section.php');
$output = '
<form action="'.rex_url::currentBackendPage().'" method="post">
<input type="hidden" name="formsubmit" value="1" />'.$output.'</form>
';
echo $output;


